# 2023-11-21 Triage Log

Pretty quiet week, with only a small number of statistically significant changes landing.

Triage done by **@simulacrum**.
Revision range: [173b6e686b158dbad7d072c64bef3ced2052312b..4f3da903a43f22ea33d2ca4435a24b42fc1f842a](https://perf.rust-lang.org/?start=173b6e686b158dbad7d072c64bef3ced2052312b&end=4f3da903a43f22ea33d2ca4435a24b42fc1f842a&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.2%, 0.9%]   | 33    |
| Regressions ❌ <br /> (secondary)  | 0.5%  | [0.2%, 1.1%]   | 17    |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -0.4% | [-0.6%, -0.3%] | 7     |
| All ❌✅ (primary)                 | 0.3%  | [0.2%, 0.9%]   | 33    |

1 Regressions, 1 Improvements, 1 Mixed; 0 of them in rollups
60 artifact comparisons made in total

#### Regressions

some additional region refactorings [#117944](https://github.com/rust-lang/rust/pull/117944) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4d7f952a02d0bca67c98a6b74895b7e3fbe38341&end=069a4af48b4b2111ff65f3895edb425683e6ae8a&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.1% | [0.1%, 0.1%] | 1     |
| Regressions ❌ <br /> (secondary)  | 0.4% | [0.3%, 1.0%] | 10    |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.1% | [0.1%, 0.1%] | 1     |

Slight regression to diesel incr-full in the primary benchmarks. That appears
to be real, but the limitation to incr-full makes me suspect it's not worth
further investigation, since that scenario is relatively rare.

#### Improvements

Update to LLVM 17.0.5 [#117907](https://github.com/rust-lang/rust/pull/117907) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=49b27f4efbb63b0a35c8d5504e2f38efec8b4d14&end=dd430bc8c22f57992ec1457a87437d14283fdd65&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -2.9% | [-2.9%, -2.9%] | 2     |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | -2.9% | [-2.9%, -2.9%] | 2     |


#### Mixed

Reenable effects in libcore [#117825](https://github.com/rust-lang/rust/pull/117825) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=547ace805166137052b2b76ee6770ef7cc8aa7c1&end=e6dade96f4f16b2c0f621d657130b90b4bb519a2&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.2%, 0.8%]   | 6     |
| Regressions ❌ <br /> (secondary)  | 0.6%  | [0.3%, 0.8%]   | 3     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -1.3% | [-1.3%, -1.3%] | 1     |
| All ❌✅ (primary)                 | 0.3%  | [0.2%, 0.8%]   | 6     |

Regressions seem real, likely due to downstream effects from libcore's metadata
getting larger? But not entirely clear; the PR does not appear to directly
change any functions/types in core.
